<?php

////////////////////////////////////////////////////////////////////////////
/// Blackboard 6.x Examview Questions
///
/// This Moodle class provides all functions necessary to import and export
///
///
////////////////////////////////////////////////////////////////////////////

// Based on default.php, included by ../import.php
/**
 * @package questionbank
 * @subpackage importexport
 */
require_once ("$CFG->libdir/xmlize.php");

class qformat_examview_blackboard extends qformat_default {
    function provide_import() {
        return true;
    }
    
    
    //Function to check and create the needed dir to unzip file to
    function check_and_create_import_dir($unique_code) {

        global $CFG; 

        $status = $this->check_dir_exists($CFG->dataroot."/temp",true);
        if ($status) {
            $status = $this->check_dir_exists($CFG->dataroot."/temp/bbquiz_import",true);
        }
        if ($status) {
            $status = $this->check_dir_exists($CFG->dataroot."/temp/bbquiz_import/".$unique_code,true);
        }
        
        return $status;
    }
    
    function clean_temp_dir($dir='') {
        // for now we will just say everything happened okay note 
        // that a mess may be piling up in $CFG->dataroot/temp/bbquiz_import
        return true;
        
        if ($dir == '') {
            $dir = $this->temp_dir;   
        }
        $slash = "/";

        // Create arrays to store files and directories
        $dir_files      = array();
        $dir_subdirs    = array();

        // Make sure we can delete it
        chmod($dir, 0777);

        if ((($handle = opendir($dir))) == FALSE) {
            // The directory could not be opened
            return false;
        }

        // Loop through all directory entries, and construct two temporary arrays containing files and sub directories
        while(false !== ($entry = readdir($handle))) {
            if (is_dir($dir. $slash .$entry) && $entry != ".." && $entry != ".") {
                $dir_subdirs[] = $dir. $slash .$entry;
            }
            else if ($entry != ".." && $entry != ".") {
                $dir_files[] = $dir. $slash .$entry;
            }
        }

        // Delete all files in the curent directory return false and halt if a file cannot be removed
        for($i=0; $i<count($dir_files); $i++) {
            chmod($dir_files[$i], 0777);
            if (((unlink($dir_files[$i]))) == FALSE) {
                return false;
            }
        }

        // Empty sub directories and then remove the directory
        for($i=0; $i<count($dir_subdirs); $i++) {
            chmod($dir_subdirs[$i], 0777);
            if ($this->clean_temp_dir($dir_subdirs[$i]) == FALSE) {
                return false;
            }
            else {
                if (rmdir($dir_subdirs[$i]) == FALSE) {
                return false;
                }
            }
        }

        // Close directory
        closedir($handle);
        if (rmdir($this->temp_dir) == FALSE) {
            return false;    
        }
        // Success, every thing is gone return true
        return true;
    }
    
    //Function to check if a directory exists and, optionally, create it
    function check_dir_exists($dir,$create=false) {

        global $CFG; 

        $status = true;
        if(!is_dir($dir)) {
            if (!$create) {
                $status = false;
            } else {
                umask(0000);
                $status = mkdir ($dir,$CFG->directorypermissions,true);
            }
        }
        return $status;
    }

    function importpostprocess() {
    /// Does any post-processing that may be desired
    /// Argument is a simple array of question ids that 
    /// have just been added.
    
        // need to clean up temporary directory
        return $this->clean_temp_dir();
    }

    // Assumes /res00001/$filename
    // $filebase should be something like 'res00001'
    function copy_file_to_course ($filename, $filebase) {

        global $CFG, $COURSE;
        
        // print "copy file to course";
        $filename = str_replace('\\','/',$filename);
        $fullpath = $this->temp_dir.'/'.$filebase.'/'.$filename;
        $basename = basename($filename);
        $dirname = dirname($filename);
    
        $copy_to = $CFG->dataroot.'/1/questions/'.$COURSE->id.'/bb_import';
        
        if ($this->check_dir_exists($copy_to.'/'.$dirname,true)) {
            if(is_readable($fullpath)) {
                $copy_to.= '/'.$dirname.'/'.$basename;
                //print " " . $copy_to;
                if (!copy($fullpath, $copy_to)) {
                    return false;
                }
                else {
                    return $copy_to;
                }
            }
        }
        else {
            return false;   
        }
    }

    function readdata($filename) {
    /// Returns complete file with an array, one item per line
        global $CFG, $COURSE;
        
        $unique_code = time();
        $temp_dir = $CFG->dataroot."/temp/bbquiz_import/".$unique_code;
        $this->temp_dir = $temp_dir;
        if ($this->check_and_create_import_dir($unique_code)) {
            if(is_readable($filename)) {
                if (!copy($filename, "$temp_dir/bboard.zip")) {
                    error("Could not copy backup file");
                }
                if(unzip_file("$temp_dir/bboard.zip", '', false)) {
                    // assuming that the information is in res0001.dat
                    // after looking at 6 examples this was always the case

					$dom = new DomDocument();
					
					if (!$dom->load("$temp_dir/imsmanifest.xml")) {
					  error ("Error while parsing the IMS manifest document\n");
					  exit;
					}
					
					$xpath = new DOMXPath($dom);
					
					
					// We starts from the root element
					$query = '//resources/resource';
					$q_base = 'res00001';
                    			$q_file = "$temp_dir/res00001.dat";
                    
                    
					$examfiles = $xpath->query($query);
					foreach ($examfiles as $examfile) {
						//print "Found {$examfile->getAttribute('file')}<br>\n";
						$q_file = $examfile->getAttribute('file');
						$q_base = $examfile->getAttribute('baseurl');
					}
					
					// We starts from the root element
					$query = '//resources/resource/file';
					
					$entries = $xpath->query($query);
					
					foreach ($entries as $entry) {
						//print "Found {$entry->getAttribute('href')} at $q_base<br>\n";
						//print $COURSE->id . "<br>" . $entry->getAttribute('href');
						//print "Calling copy_file_to_course";
						$filename = $entry->getAttribute('href');
						$this->copy_file_to_course($filename, $q_base);
						//print "...";
					
					}

                    $q_file = "$temp_dir/$q_file";
                    //print $qfile;
                    if (is_file($q_file)) {
                        if (is_readable($q_file)) {
                            $filearray = file($q_file);
                            for ($i = 0; $i < sizeof($filearray); $i++) {
                            	$filearray[$i] = str_replace('src="','src="'.$CFG->wwwroot.'/file.php/1/questions/'.$COURSE->id.'/bb_import/',$filearray[$i]);
                            }
                            
                            /// Check for Macintosh OS line returns (ie file on one line), and fix
                            if (ereg("\r", $filearray[0]) AND !ereg("\n", $filearray[0])) {
                                return explode("\r", $filearray[0]);
                            } else {
                                return $filearray;
                            }
                            return false;        
                        }
                    }
                    else {
                        error("Could not find question data file in zip");   
                    }
                }
                else {
                    print "filename: $filename<br />tempdir: $temp_dir <br />";
                    error("Could not unzip file.");   
                }
            }
            else {
                error ("Could not read uploaded file");   
            }
        }
        else {
            error("Could not create temporary directory");   
        }
    }
        
    function save_question_options($question) {
        return true; 
    }
    

  function readquestions ($lines) {
    /// Parses an array of lines into an array of questions,
    /// where each item is a question object as defined by
    /// readquestion(). 

    $text = implode($lines, " ");
    $xml = xmlize($text, 0);

    $questions = array();

    $this->process_tf($xml, $questions);
    $this->process_mc($xml, $questions);
    $this->process_ma($xml, $questions);
    $this->process_fib($xml, $questions);
    $this->process_matching($xml, $questions);
    $this->process_essay($xml, $questions);
    
    return $questions;
}


//----------------------------------------
// Process True / False Questions
//----------------------------------------
function process_tf($xml, &$questions) {

    if (isset($xml["POOL"]["#"]["QUESTION_TRUEFALSE"])) {
        $tfquestions = $xml["POOL"]["#"]["QUESTION_TRUEFALSE"];
    }
    else {
        return;
    }

    for ($i = 0; $i < sizeof ($tfquestions); $i++) {
      
        $question = $this->defaultquestion();

        $question->qtype = TRUEFALSE;
        $question->single = 1; // Only one answer is allowed

        $thisquestion = $tfquestions[$i];

        // determine if the question is already escaped html
        $ishtml = $thisquestion["#"]["BODY"][0]["#"]["FLAGS"][0]["#"]["ISHTML"][0]["@"]["value"];

        // put questiontext in question object
        if ($ishtml) {
            $question->questiontext = html_entity_decode_php4(trim($thisquestion["#"]["BODY"][0]["#"]["TEXT"][0]["#"]));
        }
        $question->questiontext = addslashes($question->questiontext);
        // put name in question object
        $question->name = substr($question->questiontext, 0, 254);

        $choices = $thisquestion["#"]["ANSWER"];

        $correct_answer = $thisquestion["#"]["GRADABLE"][0]["#"]["CORRECTANSWER"][0]["@"]["answer_id"];

        // first choice is true, second is false.
        $id = $choices[0]["@"]["id"];

        if (strcmp($id, $correct_answer) == 0) {  // true is correct
            $question->answer = 1;
            $question->feedbacktrue = addslashes(trim(@$thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_CORRECT"][0]["#"]));
            $question->feedbackfalse = addslashes(trim(@$thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_INCORRECT"][0]["#"]));
        } else {  // false is correct
            $question->answer = 0;
            $question->feedbacktrue = addslashes(trim(@$thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_INCORRECT"][0]["#"]));
            $question->feedbackfalse = addslashes(trim(@$thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_CORRECT"][0]["#"]));
        }
        $question->correctanswer = $question->answer;
        $questions[] = $question;
      }
}



//----------------------------------------
// Process Multiple Choice Questions
//----------------------------------------
function process_mc($xml, &$questions) {

    if (isset($xml["POOL"]["#"]["QUESTION_MULTIPLECHOICE"])) {
        $mcquestions = $xml["POOL"]["#"]["QUESTION_MULTIPLECHOICE"];
    }
    else {
        return;
    }

    for ($i = 0; $i < sizeof ($mcquestions); $i++) {

        $question = $this->defaultquestion();

        $question->qtype = MULTICHOICE;
        $question->single = 1; // Only one answer is allowed

        $thisquestion = $mcquestions[$i];

        // determine if the question is already escaped html
        $ishtml = $thisquestion["#"]["BODY"][0]["#"]["FLAGS"][0]["#"]["ISHTML"][0]["@"]["value"];

        // put questiontext in question object
        if ($ishtml) {
            $question->questiontext = html_entity_decode_php4(trim($thisquestion["#"]["BODY"][0]["#"]["TEXT"][0]["#"]));
        }
        $question->questiontext = addslashes($question->questiontext);

        // put name of question in question object, careful of length
        $question->name = substr(strip_tags($question->questiontext), 0, 254);

        $choices = $thisquestion["#"]["ANSWER"];
        for ($j = 0; $j < sizeof ($choices); $j++) {

            $choice = trim($choices[$j]["#"]["TEXT"][0]["#"]);
            // put this choice in the question object.
            if ($ishtml) {
                $question->answer[$j] = html_entity_decode_php4($choice);
            }
            $question->answer[$j] = addslashes($question->answer[$j]);

            $id = $choices[$j]["@"]["id"];
            $correct_answer_id = $thisquestion["#"]["GRADABLE"][0]["#"]["CORRECTANSWER"][0]["@"]["answer_id"];
            // if choice is the answer, give 100%, otherwise give 0%
            if (strcmp ($id, $correct_answer_id) == 0) {
                $question->fraction[$j] = 1;
                if ($ishtml) {
                    $question->feedback[$j] = html_entity_decode_php4(trim(@$thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_CORRECT"][0]["#"]));
                }
                $question->feedback[$j] = addslashes($question->feedback[$j]);
            } else {
                $question->fraction[$j] = 0;
                if ($ishtml) {
                    $question->feedback[$j] = html_entity_decode_php4(trim(@$thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_INCORRECT"][0]["#"]));
                }
                $question->feedback[$j] = addslashes($question->feedback[$j]);
            }
        }
        $questions[] = $question;
    }
}

//----------------------------------------
// Process Multiple Choice Questions With Multiple Answers
//----------------------------------------
function process_ma($xml, &$questions) {

    if (isset($xml["POOL"]["#"]["QUESTION_MULTIPLEANSWER"])) {
        $maquestions = $xml["POOL"]["#"]["QUESTION_MULTIPLEANSWER"];
    }
    else {
        return;
    }

    for ($i = 0; $i < sizeof ($maquestions); $i++) {

        $question = $this->defaultquestion();

        $question->qtype = MULTICHOICE;
        $question->defaultgrade = 1;
        $question->single = 0; // More than one answers allowed
        $question->image = ""; // No images with this format

        $thisquestion = $maquestions[$i];

        // determine if the question is already escaped html
        $ishtml = $thisquestion["#"]["BODY"][0]["#"]["FLAGS"][0]["#"]["ISHTML"][0]["@"]["value"];

        // put questiontext in question object
        if ($ishtml) {
            $question->questiontext = html_entity_decode_php4(trim($thisquestion["#"]["BODY"][0]["#"]["TEXT"][0]["#"]));
        }
        $question->questiontext = addslashes($question->questiontext);
        // put name of question in question object
        $question->name = substr(strip_tags($question->questiontext), 0, 254);

        $choices = $thisquestion["#"]["ANSWER"];
        $correctanswers = $thisquestion["#"]["GRADABLE"][0]["#"]["CORRECTANSWER"];
	$question->defaultgrade = sizeof($correctanswers);

        for ($j = 0; $j < sizeof ($choices); $j++) {

            $choice = trim($choices[$j]["#"]["TEXT"][0]["#"]);
            // put this choice in the question object.
            $question->answer[$j] = addslashes($choice);

            $correctanswercount = sizeof($correctanswers);
            $id = $choices[$j]["@"]["id"];
            $iscorrect = 0;
            for ($k = 0; $k < $correctanswercount; $k++) {

                $correct_answer_id = trim($correctanswers[$k]["@"]["answer_id"]);
                if (strcmp ($id, $correct_answer_id) == 0) {
                    $iscorrect = 1;
                }

            }
            if ($iscorrect) { 
                $question->fraction[$j] = floor(100000/$correctanswercount)/100000; // strange behavior if we have more than 5 decimal places
                $question->feedback[$j] = addslashes(trim($thisquestion["#"]["GRADABLE"][$j]["#"]["FEEDBACK_WHEN_CORRECT"][0]["#"]));
            } else {
                $question->fraction[$j] = 0;
                $question->feedback[$j] = addslashes(trim($thisquestion["#"]["GRADABLE"][$j]["#"]["FEEDBACK_WHEN_INCORRECT"][0]["#"]));
            }
        }

        $questions[] = $question;
    }
}

//----------------------------------------
// Process Fill in the Blank Questions
//----------------------------------------
function process_fib($xml, &$questions) {

    if (isset($xml["POOL"]["#"]["QUESTION_FILLINBLANK"])) {
        $fibquestions = $xml["POOL"]["#"]["QUESTION_FILLINBLANK"];
    }
    else {
        return;
    }

    for ($i = 0; $i < sizeof ($fibquestions); $i++) {
        $question = $this->defaultquestion();

        $question->qtype = SHORTANSWER;
        $question->usecase = 0; // Ignore case

        $thisquestion = $fibquestions[$i];

        // determine if the question is already escaped html
        $ishtml = $thisquestion["#"]["BODY"][0]["#"]["FLAGS"][0]["#"]["ISHTML"][0]["@"]["value"];

        // put questiontext in question object
        if ($ishtml) {
            $question->questiontext = html_entity_decode_php4(trim($thisquestion["#"]["BODY"][0]["#"]["TEXT"][0]["#"]));
        }
        $question->questiontext = addslashes($question->questiontext);
        // put name of question in question object
        $question->name = substr(strip_tags($question->questiontext), 0, 254);

        $answer = trim($thisquestion["#"]["ANSWER"][0]["#"]["TEXT"][0]["#"]);

        $question->answer[] = addslashes($answer);
        $question->fraction[] = 1;
        $question->feedback = array();

        if (is_array( $thisquestion['#']['GRADABLE'][0]['#'] )) {
            $question->feedback[0] = addslashes(trim($thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_CORRECT"][0]["#"]));
        }
        else {
            $question->feedback[0] = '';
        }      
        if (is_array( $thisquestion["#"]["GRADABLE"][0]["#"] )) {
            $question->feedback[1] = addslashes(trim($thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_INCORRECT"][0]["#"]));
        }
        else {
            $question->feedback[1] = '';
        }        
         
        $questions[] = $question;
    }
}


//----------------------------------------
// Process Essay Questions
//----------------------------------------
function process_essay($xml, &$questions) {

    if (isset($xml["POOL"]["#"]["QUESTION_ESSAY"])) {
        $essquestions = $xml["POOL"]["#"]["QUESTION_ESSAY"];
    }
    else {
        return;
    }

    for ($i = 0; $i < sizeof ($essquestions); $i++) {
        $question = $this->defaultquestion();

        $question->qtype = ESSAY;
        $question->usecase = 0; // Ignore case

        $thisquestion = $essquestions[$i];

        // determine if the question is already escaped html
        $ishtml = $thisquestion["#"]["BODY"][0]["#"]["FLAGS"][0]["#"]["ISHTML"][0]["@"]["value"];

        // put questiontext in question object
        if ($ishtml) {
            $question->questiontext = html_entity_decode_php4(trim($thisquestion["#"]["BODY"][0]["#"]["TEXT"][0]["#"]));
        }
        $question->questiontext = addslashes($question->questiontext);
        // put name of question in question object
        $question->name = substr(strip_tags($question->questiontext), 0, 254);

        $answer = trim($thisquestion["#"]["ANSWER"][0]["#"]["TEXT"][0]["#"]);

        $question->answer[] = addslashes($answer);
        $question->fraction[] = 1;
        $question->feedback = array();

        if (is_array( $thisquestion['#']['GRADABLE'][0]['#'] )) {
            $question->feedback[0] = addslashes(trim($thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_CORRECT"][0]["#"]));
        }
        else {
            $question->feedback[0] = '';
        }      
        if (is_array( $thisquestion["#"]["GRADABLE"][0]["#"] )) {
            $question->feedback[1] = addslashes(trim($thisquestion["#"]["GRADABLE"][0]["#"]["FEEDBACK_WHEN_INCORRECT"][0]["#"]));
        }
        else {
            $question->feedback[1] = '';
        }        
         
        $questions[] = $question;
    }
}


//----------------------------------------
// Process Matching Questions
//----------------------------------------
function process_matching($xml, &$questions) {

    if (isset($xml["POOL"]["#"]["QUESTION_MATCH"])) {
        $matchquestions = $xml["POOL"]["#"]["QUESTION_MATCH"];
    }
    else {
        return;
    }

    for ($i = 0; $i < sizeof ($matchquestions); $i++) {

        $question = $this->defaultquestion();

        $question->qtype = MATCH;

        $thisquestion = $matchquestions[$i];

        // determine if the question is already escaped html
        $ishtml = $thisquestion["#"]["BODY"][0]["#"]["FLAGS"][0]["#"]["ISHTML"][0]["@"]["value"];

        // put questiontext in question object
        if ($ishtml) {
            $question->questiontext = html_entity_decode_php4(trim($thisquestion["#"]["BODY"][0]["#"]["TEXT"][0]["#"]));
        }
        $question->questiontext = addslashes($question->questiontext);
        // put name of question in question object
        $question->name = substr(strip_tags($question->questiontext), 0, 254);

        $choices = $thisquestion["#"]["CHOICE"];
        for ($j = 0; $j < sizeof ($choices); $j++) {

            $subquestion = NULL;

            $choice = $choices[$j]["#"]["TEXT"][0]["#"];
            $choice_id = $choices[$j]["@"]["id"];
          
            $question->subanswers[] = addslashes(trim($choice));
 
            $correctanswers = $thisquestion["#"]["GRADABLE"][0]["#"]["CORRECTANSWER"];
            for ($k = 0; $k < sizeof ($correctanswers); $k++) {

                if (strcmp($choice_id, $correctanswers[$k]["@"]["choice_id"]) == 0) {

                    $answer_id = $correctanswers[$k]["@"]["answer_id"];

                    $answers = $thisquestion["#"]["ANSWER"];
                    for ($m = 0; $m < sizeof ($answers); $m++) {

                        $answer = $answers[$m];
                        $current_ans_id = $answer["@"]["id"];
                        if (strcmp ($current_ans_id, $answer_id) == 0) {

                            $answer = $answer["#"]["TEXT"][0]["#"];
                            $question->subquestions[] = addslashes(trim($answer));
                            break;

                        }

                    }

                    break;

                }

            }
           
        }

        $questions[] = $question;
          
    }
}    

} // close object
?>
